Iris texture is almost completely randotipic, that's why it's useful for recognition.

The iris is a muscle membrane of the eye, of variable color, with both shape and function of a diaphragm.
- it is pigmented, located posterior to the cornea and in front of the lens, and is perforated by pupil
- consists of a flat layer of muscle fibers which circularly surround the pupil, a thin layer of smooth muscle fibers by means of which the pupil is dilated and posteriorly by two layers of epithelial pigmented cells
- it contains recular texture (mostly by furrows) and irrecular patterns (e.g. freckless and crypts), these combined with the color provides a very high level of discrimination, comparable to fingerprints.
![[Pasted image 20241128083519.png]]

**Pros:**
- iris is visible yet well protected
- time invariant (after about 2 years of age)
- extremely distinguishing trait (right different from left, even twins have different irises)
- no direct contact required
- acquisition via both near infrared and visible wavelenghts
**Cons:**
- limited iris surface (about $3.64cm^2$)
- short distance required ($< 1m$), however it depends on the resolution of the capture device
- limited depth of field
- need to consider gaze direction (sguardo)
	- better if the gaze direction is the same
- presence of glasses
- presence of contact lenses
	- especially cosmetic lenses
		- (lens may be detected, as they may be camouflage or spoofing attempts)

### Iris capture modalities
Two ways:
- **Visible light:**
	- melanin absorbs visible light
	- layers that make up the iris are well visible
	- however, the image contains noisy information (such as reflections)
		- but areas with reflections can be ignored in matching
- **Infrared light:**
	- melanin reflects most of the infrared light
	- texture is more visible
	- best suited in biometric systems based on iris recognition
	- however, special equipment is required
![[Pasted image 20241128090512.png]]

### Processing phases
- The presence of noisy elements requires a good pre-processing/segmentation
- we don't want to process the pupil
![[Pasted image 20241128091236.png]]
The inner contour of the eye may change on illumination changes as pupil dilates. Normalization tries to make templates comparable (wit the same size). Then we have the coding fase, that extracts useful information.

##### John Daugman approach (the most famous)
![[Pasted image 20241128091305.png]]
- strictly near infrared

- uses a kind of circular edge detector to localize both the pupil and the iris
- exploits the convolution of the image with a Gaussian smoothing function with center $r_{0}$ and standard deviation $\sigma$
- the operator looks for a circular path along which pixel variation is maximized, by varying the center $r$ and radius $(x0, y0)$ of a candidate circular contour
- when the candidate circle has the same radius and center of the iris, the operator should provide a peak
  ![[Pasted image 20241128100043.png|300]]


- similar procedure for looking at eyelids, but instead of looking cor circular paths the operator looks for archs, which are approximated by splines
  ![[Pasted image 20241128100329.png|300]]

- at the end, we obtain a mask (so that only iris pixels are processed)
##### Unwrapping
- we can now use an unwrapping algorithm
- simple with polar coordinates (circular bands become horizontal stripes)
- it is important to detect the right centre for the polar coordinates
	- but pupil and iris are not perfectly concentric!
	- size of the pupil can change!
	- gaze direction can change the relative position of sclera, iris and pupil
- a normalization procedure is necessary: Rubber Sheet Model
![[Pasted image 20241128101031.png]]
L’iris unwrapping è il processo di trasformazione dall'iride circolare in
coordinate cartesiane in un rettangolo in coordinate pseudopolari.
Determinare il giusto centro per le coordinate polari è di fondamentale
importanza, ma la pupilla e l'iride non sono perfettamente concentriche e le
dimensioni della pupilla possono cambiare a causa dell'illuminazione o di
condizioni patologiche (ubriachezza o droghe).
##### Rubber Sheet Model
- maps each iris point onto polar coordinates $(r, \theta)$ with $r \in [0, 1]$ and $\theta \in [0, 2\pi]$
- the model compensates for pupil dilation and size variation by producing a invariant representation
- does not compensate for rotations. But it is done during matching by translating the templates until alignment

Il **Rubber Sheet Model** è una tecnica di normalizzazione che si applica in contesti come il riconoscimento dell'iride, dove le distorsioni della pupilla e dell'iride, dovute alla variabilità fisiologica e alla posizione della fotocamera, devono essere correttamente gestite.
- Si considerano più punti distribuiti lungo ogni raggio che va dal confine della pupilla al confine dell'iride, in modo da normalizzare la distanza che potrebbe essere deformata a causa della dilatazione della pupilla o della deformazione naturale dell'iride.
- Ogni punto sull'iride viene mappato in un sistema di coordinate polari, con il centro della pupilla che diventa l'origine del sistema di coordinate.
- La trasformazione avviene tramite una combinazione lineare delle coordinate dei punti sul contorno della pupilla e quelli sul contorno dell'iride, per "distendere" la superficie iridata in modo da correggere le distorsioni.

Questo modello è utile per migliorare l'accuratezza nel riconoscimento dell'iride, poiché permette di ridurre gli effetti di variazioni nella forma e dimensione dell'occhio, garantendo una rappresentazione standardizzata che facilita il confronto tra immagini diverse.

##### Daugman: Feature extraction
- Gabor filters to the image in polar coordinates (formula on slide)
- for each element with coordinates $(r, \theta)$ in the image $I(\rho, \phi)$, the method computes a pair of bits
- ... are discretized to obtain a 256 byte code, plus a mask of the same size to identify valid iris elements
...complete with slides...

![[Pasted image 20241128102138.png]]

### NICE competition
cose

> [!PDF|yellow] [[LEZIONE10_Iris recognition.pdf#page=48&color=yellow|LEZIONE10_Iris recognition, p.48]]
> > Canny filtering
> 
> i punti sono considerati se adiacenti ad altri edge